<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-6" style="padding-left:0;">
                <div class="card">
                    <div class="card-header"></div>
                    <div class="card-body">
                        <div v-if="fileUploadSuccess!=''" class="alert alert-success" role="alert">
                            {{fileUploadSuccess}}
                        </div>

                        <form @submit="formSubmit" enctype="multipart/form-data">
                            <div class="row">
                                <div class="col-md-12">
                                    <label>Upload a template</label>
                                    <br/>
                                </div>
                                <div class="col-md-8" style="display:flex;justify-content: space-between">
                                    <input type="file" v-on:change="onFileChange">
                                    <button class="btn btn-success">Upload</button>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12">
                                    <div v-if="fileUploadError" class="text-danger"> {{ fileUploadError.file[0] }} </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>

            <div class="col-md-6" id="table">
                <div v-if="items.length>0">
                   <table class="table table-borderless" id="table">
                       <thead>
                       <tr>
                           <th>ID</th>
                           <th>Name</th>
                           <th>Actions</th>
                       </tr>
                       </thead>
                       <tr v-for="item in items" style="margin-top: 10px;">
                           <td>{{ item.id }}</td>
                           <td v-on:click="test(item.id)">
                               {{ item.filename }}
                           </td>
                           <td @click.prevent="deleteItem(item)" class="btn btn-danger" style="margin-right: 5px;">
                               <i class="fa fa-trash" aria-hidden="true"></i>
                           </td>
                           <td @click="open=true;fields.documentId=item.id;docFields.documentId=item.id;getDocFields(item)" class="btn btn-default">
                               <i class="fa fa-edit"></i> Replace with data
                           </td>
                       </tr>
                       <tr v-for="field in fieldFromDoc">
                            <td>{{ field }} </td>
                       </tr>
                   </table>
                </div>
                <div v-else>
                    <h2>There are no templates</h2>
                </div>
            </div>
        </div>


        <vue-modaltor :visible="open" @hide="hideModal">

            <div class="row" style="display: flex;justify-content: center">
                <p>{{ docFields.documentId }}</p>
                <div class="col-md-6">
                    <form @submit.prevent="downloadDocument">

                      <div class="form-group" v-for="field in docFields">
                            <label>{{ field }}</label>
                            <input type="text" class="form-control" :name="field" v-model="fields[field]"/>
                            <!--<div v-if="errors && errors.name" class="text-danger"> {{ errors.name[0] }} </div>-->
                      </div>
                      <input type="hidden" name="documentId" id="" v-model="fields.documentId"/>
                      <button type="submit" class="btn btn-primary">Download</button>
                    </form>
                </div>
            </div>
        </vue-modaltor>
    </div>
</template>



<script>
    export default {
        mounted() {
            this.getTemplates();
            console.log(this.fieldFromDoc);
        },
        data() {
            return {
                items: [],
                fileUploadSuccess: '',
                fileUploadError: '',
                hasError: true,
                hasDeleted: true,
                fields: {
                    documentId: ''
                },
                errors: {},
                open: false,
                docFields: []
            };
        },
        methods: {
            onFileChange(e){
                this.file = e.target.files[0];
            },
            formSubmit(e) {
                e.preventDefault();
                const config = {
                    headers: { 'content-type': 'multipart/form-data' }
                }
                let formData = new FormData();
                formData.append('file', this.file);
                axios.post('/formSubmit', formData, config).then((response) => {
                    console.log(response);
                    this.getTemplates();
                    this.fileUploadSuccess = response.data.success;
                })
                .catch(error => {
                     this.fileUploadError = error.response.data.errors || '';
                });
            },
            getTemplates: function() {
                axios.get('/gettemplates').then(response => {
                    this.items = response.data;
                });
            },
            getDocFields: function(item) {
                axios.get('/getdocfields/'+item.id).then(response => {
                    this.docFields = response.data.fields;
                });
            },
            deleteItem: function(item) {
                if (confirm('Are you sure ?')) {
                    axios.post('/templates/'+item.id).then((response) => {
                        this.getTemplates();
                        this.hasError = true,
                        this.hasDeleted = false
                    });
                }
            },
            downloadDocument() {
                this.errors = {};
                axios.post('/submit', this.fields).then(response => {
                    let file = response.data;
                    axios.get('/generated/'+ response.data, {responseType: 'blob'})
                      .then((response) => {
                            const url = window.URL.createObjectURL(new Blob([response.data]));
                            const link = document.createElement('a');
                            link.href = url;
                            link.setAttribute('download', file);
                            document.body.appendChild(link);
                            link.click();
                      })
                }).catch(error => {
                    if (error.response.status===422) {
                        this.errors = error.response.data.errors || {};
                    }
                });
            },
            hideModal() {
                this.open = false;
            },
        },
    }
</script>